Bug 2069189 - Broken dependency wrapt<1.14,>=1.11 on Fedora 36
Summary: Broken dependency wrapt<1.14,>=1.11 on Fedora 36
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: python-astroid
Version: 36
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Zbigniew Jędrzejewski-Szmek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 2069837 2073564 (view as bug list)
Depends On: 2059163
Blocks:
TreeView+ depends on / blocked
 
Reported: 2022-03-28 12:46 UTC by Andreas Gerstmayr
Modified: 2022-05-07 04:29 UTC (History)
8 users (show)

Fixed In Version: python-astroid-2.11.3-1.fc37 python-astroid-2.11.3-1.fc36
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2022-04-22 17:42:47 UTC
Type: Bug


Attachments (Terms of Use)

Description Andreas Gerstmayr 2022-03-28 12:46:42 UTC
Description of problem:
pylint has a dependency on python3-astroid.
python3-astroid version 2.9.3 depends on wrapt>=1.11,<1.14 [1], however only version 1.14.0 of wrapt is available in Fedora 36.
Since version 2.11.0 python3-astroid has relaxed the dependency to wrapt>=1.11,<2 [2], which resolves this dependency issue.

[1] https://github.com/PyCQA/astroid/blob/v2.9.3/setup.cfg#L40
[2] https://github.com/PyCQA/astroid/commit/e346d42e92499849eb5d75ca27a648e1ce411ec7

Version-Release number of selected component (if applicable):
python-astroid-2.9.3-2.fc36
python-wrapt-1.14.0-1.fc36

How reproducible:
Always

Steps to Reproduce:
1. dnf install pylint
2. pylint


Actual results:
Traceback (most recent call last):
  File "/usr/lib/python3.10/site-packages/pkg_resources/__init__.py", line 573, in _build_master
    ws.require(__requires__)
  File "/usr/lib/python3.10/site-packages/pkg_resources/__init__.py", line 891, in require
    needed = self.resolve(parse_requirements(requirements))
  File "/usr/lib/python3.10/site-packages/pkg_resources/__init__.py", line 782, in resolve
    raise VersionConflict(dist, req).with_context(dependent_req)
pkg_resources.ContextualVersionConflict: (wrapt 1.14.0 (/usr/lib64/python3.10/site-packages), Requirement.parse('wrapt<1.14,>=1.11'), {'astroid'})

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/usr/bin/pylint", line 33, in <module>
    sys.exit(load_entry_point('pylint==2.12.2', 'console_scripts', 'pylint')())
  File "/usr/lib/python3.10/site-packages/pylint/__init__.py", line 21, in run_pylint
    from pylint.lint import Run as PylintRun
  File "/usr/lib/python3.10/site-packages/pylint/lint/__init__.py", line 76, in <module>
    from pylint.lint.parallel import check_parallel
  File "/usr/lib/python3.10/site-packages/pylint/lint/parallel.py", line 8, in <module>
    from pylint import reporters
  File "/usr/lib/python3.10/site-packages/pylint/reporters/__init__.py", line 27, in <module>
    from pylint import utils
  File "/usr/lib/python3.10/site-packages/pylint/utils/__init__.py", line 47, in <module>
    from pylint.utils.ast_walker import ASTWalker
  File "/usr/lib/python3.10/site-packages/pylint/utils/ast_walker.py", line 7, in <module>
    from astroid import nodes
  File "/usr/lib/python3.10/site-packages/astroid/__init__.py", line 51, in <module>
    from astroid.nodes import node_classes, scoped_nodes
  File "/usr/lib/python3.10/site-packages/astroid/nodes/__init__.py", line 27, in <module>
    from astroid.nodes.node_classes import (  # pylint: disable=redefined-builtin (Ellipsis)
  File "/usr/lib/python3.10/site-packages/astroid/nodes/node_classes.py", line 50, in <module>
    from astroid.bases import Instance, _infer_stmts
  File "/usr/lib/python3.10/site-packages/astroid/bases.py", line 551, in <module>
    class Generator(BaseInstance):
  File "/usr/lib/python3.10/site-packages/astroid/bases.py", line 557, in Generator
    special_attributes = lazy_descriptor(objectmodel.GeneratorModel)
  File "/usr/lib/python3.10/site-packages/astroid/util.py", line 29, in <lambda>
    lambda: importlib.import_module("." + module_name, "astroid")
  File "/usr/lib64/python3.10/importlib/__init__.py", line 126, in import_module
    return _bootstrap._gcd_import(name[level:], package, level)
  File "/usr/lib/python3.10/site-packages/astroid/interpreter/objectmodel.py", line 44, in <module>
    from astroid.manager import AstroidManager
  File "/usr/lib/python3.10/site-packages/astroid/manager.py", line 38, in <module>
    from astroid.interpreter._import import spec
  File "/usr/lib/python3.10/site-packages/astroid/interpreter/_import/spec.py", line 27, in <module>
    from . import util
  File "/usr/lib/python3.10/site-packages/astroid/interpreter/_import/util.py", line 7, in <module>
    import pkg_resources
  File "/usr/lib/python3.10/site-packages/pkg_resources/__init__.py", line 3267, in <module>
    def _initialize_master_working_set():
  File "/usr/lib/python3.10/site-packages/pkg_resources/__init__.py", line 3241, in _call_aside
    f(*args, **kwargs)
  File "/usr/lib/python3.10/site-packages/pkg_resources/__init__.py", line 3279, in _initialize_master_working_set
    working_set = WorkingSet._build_master()
  File "/usr/lib/python3.10/site-packages/pkg_resources/__init__.py", line 575, in _build_master
    return cls._build_from_requirements(__requires__)
  File "/usr/lib/python3.10/site-packages/pkg_resources/__init__.py", line 588, in _build_from_requirements
    dists = ws.resolve(reqs, Environment())
  File "/usr/lib/python3.10/site-packages/pkg_resources/__init__.py", line 777, in resolve
    raise DistributionNotFound(req, requirers)
pkg_resources.DistributionNotFound: The 'wrapt<1.14,>=1.11' distribution was not found and is required by astroid


Expected results:
Show pylint help message.

Additional info:
The upgrade of python-astroid in BZ 2059163 resolves this issue.

Comment 1 Pavel Raiskup 2022-03-29 07:29:56 UTC
I blocked the udpate yesterday:
https://bodhi.fedoraproject.org/updates/FEDORA-2022-bba9b410c4

Comment 2 Andreas Gerstmayr 2022-03-29 11:00:57 UTC
(In reply to Pavel Raiskup from comment #1)
> I blocked the udpate yesterday:
> https://bodhi.fedoraproject.org/updates/FEDORA-2022-bba9b410c4

Thanks!

To be honest I didn't realize that I have the fedora-updates-testing repository enabled (it is enabled by default on the Fedora 36 container, caught me by surprise).

Comment 3 Andrey Motoshkov 2022-04-06 08:47:01 UTC
updates-testing is enabled by default in beta.
Workaround:
Change in /usr/lib/python3.10/site-packages/astroid-2.9.3-py3.10.egg-info/requires.txt:
wrapt<1.14,>=1.11  >>> wrapt<=1.14,>=1.11

Comment 4 Mukundan Ragavan 2022-04-09 13:51:04 UTC
*** Bug 2073564 has been marked as a duplicate of this bug. ***

Comment 5 Zbigniew Jędrzejewski-Szmek 2022-04-22 07:19:59 UTC
*** Bug 2069837 has been marked as a duplicate of this bug. ***

Comment 6 Fedora Update System 2022-04-22 17:35:32 UTC
FEDORA-2022-64d51d1877 has been submitted as an update to Fedora 37. https://bodhi.fedoraproject.org/updates/FEDORA-2022-64d51d1877

Comment 7 Fedora Update System 2022-04-22 17:37:06 UTC
FEDORA-2022-5236a62e55 has been submitted as an update to Fedora 36. https://bodhi.fedoraproject.org/updates/FEDORA-2022-5236a62e55

Comment 8 Fedora Update System 2022-04-22 17:42:47 UTC
FEDORA-2022-64d51d1877 has been pushed to the Fedora 37 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 9 Fedora Update System 2022-04-23 17:13:48 UTC
FEDORA-2022-5236a62e55 has been pushed to the Fedora 36 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2022-5236a62e55`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-5236a62e55

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 10 Fedora Update System 2022-05-07 04:29:58 UTC
FEDORA-2022-5236a62e55 has been pushed to the Fedora 36 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.